/* RxXL_Automation_006.rex */
    parse source src
    d_title = substr(src,src~lastpos('\')+1,src~length-src~lastpos('\'))

/*
The purpose of this application is simply to create a couple of text files for direct load
into Excel

RxXL1.txt will be a text file using the ';' as a delimeter
RxXL2.csv will be a text file using the ',' as a delimeter (.csv)
RxXL3.txt will be a text file using the '^' as a delimeter
*/
    slowdown = .true

--Clear the screen
    call SysCls

--Create a .txt file with random values delimeted with a semi-colom
    if slowdown then
        do
            smsg = .infoDlg~new(d_title,'Create .txt ; delimited file')
            smsg~Execute('ShowTop')
        end
    txtStream = .stream~new('.\RxXL1.txt')
    if txtStream~query('exists') \= '' then
        do
            thefile = txtStream~Qualify
            call SysFileDelete(thefile)
        end
    do lines = 1 to 25
        aline = ''
        do fields = 1 to 20
            aline = aline||random()';'
        end
        aline = aline~strip('t',';')
        txtStream~lineout(aline)
    end
    txtStream~Close

--Create a .csv file with random values delimeted with a comma
    if slowdown then
        do
            smsg = .infoDlg~new(d_title,'Create .csv , delimited file')
            smsg~Execute('ShowTop')
        end
    csvStream = .stream~new('.\RxXL1.csv')
    if csvStream~query('exists') \= '' then
        do
            thefile = csvStream~Qualify
            call SysFileDelete(thefile)
        end
    do lines = 1 to 25
        aline = ''
        do fields = 1 to 20
            aline = aline||random()','
        end
        aline = aline~strip('t',',')
        csvStream~lineout(aline)
    end
    csvStream~Close

--Create a .txt file with random values delimeted with a not-so-common delimeter '^'
    if slowdown then
        do
            smsg = .infoDlg~new(d_title,'Create .txt ^ delimited file')
            smsg~Execute('ShowTop')
        end
    txt2Stream = .stream~new('.\RxXL3.txt')
    if txt2Stream~query('exists') \= '' then
        do
            thefile = txt2Stream~Qualify
            call SysFileDelete(thefile)
        end
    do lines = 1 to 25
        aline = ''
        do fields = 1 to 20
            aline = aline||random()'^'
        end
        aline = aline~strip('t','^')
        txt2Stream~lineout(aline)
    end
    txt2Stream~Close

    if slowdown then
        do
            smsg = .infoDlg~new(d_title,'All 3 text files should be in the current folder')
            smsg~Execute('ShowTop')
        end
exit

::requires 'oodwin32.cls'
::class infoDlg subclass userdialog public
::method Init
    expose width height d_title d_text
    use arg d_title, d_text
    self~Init:super()
    width = 350
    height = 45
    rc=self~CreateCenter(width,height,d_title,,,'Arial',10)

::method DefineDialog
    expose width height d_title d_text
    forward class(super) continue
    self~AddButton( 1,width-60 ,height-20,50,15,'OK','Ok','DEFAULT')
    self~AddText(1,5,350,15,d_text)

::method Ok
    self~OK:super
return self~finished


