/* RxXL_Automation_901.rex */

/*
There seems to be an issue with Excel in that if one Rexx application calls another Rexx
application that performs Excel automation, the ~quit method fails to execute.  This is not
an issue with ooRexx as I have read numerous reports of this happening with other languages
as well.

This program will use WMI to find and kill ALL Excel process running on the system

This little utility can be incoorporated into other programs, plus it is quit useful during
Excel automation development when your program "might" crash and leave orphaned copies of
Excel running.

It causes NO harm to run this even if there are no Excel processes running.
*/

    wmiobj = .OleObject~GetObject('winmgmts:{impersonationlevel=impersonate}')
    excel_list = wmiobj~execquery('select * from win32_process where name = ''excel.exe''')
    excel_counter = 0
    do excel_process over excel_list
        excel_counter = excel_counter + 1
        excel_process~terminate()
    end
    if excel_counter = 1 then
        say 'Terminated' excel_counter 'copy of Excel'
    else
        say 'Terminated' excel_counter 'copies of Excel'
exit
