/* gkm.rex */
    parse arg oleobj

    outfile = 'methods.txt'
    if stream(outfile,'c','query exists') \= '' then
        rv = SysFileDelete(outfile)

    call Methods
    call Constants
exit

Methods:
    oline = 'Methods/Parameters For' oleobj
    call RitIt
    oline = 'Usage: myOleObject = .OLEObject~new('oleobj')'
    call RitIt

    oline = ' '
    call RitIt

    say 'Creating Object' oleobj
    myOLEObject = .OLEObject~new(oleobj)
    QuitOK = .False
    say 'Gathering Methods/Properties'
    methods. = myOLEObject~GetKnownMethods
    if methods. == .nil then
        do
            say "Sorry, no information on the methods available!"
            return
        end
    else
        do
            ctr = 0
            do i = 1 to methods.0
                if methods.i.!NAME = 'Quit' then
                    QuitOK = .True
                ctr = ctr + 1
                oline.ctr = ''
                oline.ctr = oline.ctr||left(methods.i.!NAME,30,' ')'~'
                oline.ctr = oline.ctr||methods.i.!INVKIND'~'
                oline.ctr = oline.ctr||methods.i.!PARAMS.0';'
                do aa = 1 to methods.i.!PARAMS.0
                    oline.ctr = oline.ctr||methods.i.!PARAMS.aa.!NAME':'
                    oline.ctr = oline.ctr||methods.i.!PARAMS.aa.!TYPE':'
                    oline.ctr = oline.ctr||methods.i.!PARAMS.aa.!FLAGS'*'
                end
            end
        end

    say 'Sorting Methods/Properties'
    oline.0 = ctr
    rv = SysStemSort(oline.,"A","I",1,ctr,1,30)
    say 'rv of method/property sort was' rv

    say 'Dumping Methods/Properties To' outfile
    do aa = 1 to ctr
        parse var oline.aa name'~'ik'~'parm';'.
        oline = 'Method Name:' name
        call Ritit
        oline = '    InvKind:     ' ik
        select
            when ik = 1 then
                oline = oline 'Method'
            when ik = 2 then
                oline = oline 'Property GET'
            when ik = 4 then
                oline = oline 'Property PUT'
            otherwise
                nop
        end
        call Ritit
        oline = '    Parameters:  ' parm
        call Ritit
        if parm > 0 then
            do
                parse var oline.aa .';'parms
                spos = 1
                do until pos('*',parms,spos) < 1
                    nxt = pos('*',parms,spos)
                    qty = nxt - spos
                    aparm = substr(parms,spos,qty)
                    parse var aparm p1':'p2':'p3
                    oline = '        Parameter Name:    'p1
                    call Ritit
                    oline = '            Parameter Type:   'p2
                    call Ritit
                    oline = '            Parameter Flags:  'p3
                    call Ritit
                    spos = nxt+1
                end
            end
        oline = ' '
        call Ritit
    end
return

Constants:
    say 'Gathering Constants'
    constants. = myOLEObject~GetConstant
    ctr = 0
    drop sconstants.
    do i over constants.
        ctr = ctr + 1
        sconstants.ctr = i~strip('l','!') '=' constants.i
    end

    say 'Dumping Constants To' outfile
    oline = ''
    call RitIt
    if ctr > 0 then
        do
            oline = 'Constants Provided By' oleobj
            call Ritit
            sconstants.0 = ctr
            rv = SysStemSort(sconstants.,"A","I",1,ctr,1,30)
            say 'rv of constant sort was' rv
            do aa = 1 to sconstants.0
                oline = sconstants.aa
                call Ritit
            end
        end
    else
        do
            oline = 'No Constants Defined In' oleobj
            call Ritit
        end

    rv = stream(outfile,'c','close')
    if QuitOK then
        do
            say 'QuitOK'
            myOLEObject~Quit
        end
return

Ritit:
    rv = lineout(outfile,oline)
    return

