/* printerobject_demo.rex */

    if RxFuncQuery("InfoMessage") \= 0 then do
        call Rxfuncadd "InfoMessage", "oodialog", "InfoMessage"
    end
    if RxFuncQuery("ErrorMessage") \= 0 then do
        call Rxfuncadd "ErrorMessage", "oodialog", "ErrorMessage"
    end

    save_default_printer = SysWinGetDefaultPrinter()
    parse value save_default_printer with dp','.
    call SysWinGetPrinters all_printers.
    do aa = 1 to all_printers.0
        parse var all_printers.aa pname','.
        if pname == dp then do
            aprt.aa = pname '(Default)'
            ldp = aa
        end
        else aprt.aa = pname
    end

    aprt.0 = all_printers.0

    printer_change = .false
    m_title = 'Select A Printer For This Session'
    dlg = .SingleSelection~new('Make A Selection',m_title,aprt.,ldp)
    wt = dlg~execute
    if wt \= '' then do
        if all_printers.wt \= save_default_printer then do
            call SysWinSetDefaultPrinter all_printers.wt
            printer_change = .true
        end
    end
    else exit
    call infoMessage('This Print Session Will Use' SysWinGetDefaultPrinter())

    signal on any name Bad_Error
    oprn = .OleObject~New('RxVB.PrinterObject')
    oprn~InitializePrinter()
    oprn~Orientation = 1
    oprn~ColorMode = 2
    oprn~Copies = 1
    oprn~FontName = 'Arial'
    oprn~FontSize = 12
    oprn~AppTitle = 'PrinterObject_Demo'
    red = oprn~ConvertToRGB(255,0,0)
    black = oprn~ConvertToRGB(0,0,0)
    blue = oprn~ConvertToRGB(1,125,255)

    oprn~CurrentY = .5

    oprn~PrintLine(oprn~Ver)

    oprn~PrintLine('This Was Printed On' oprn~PrName)

    text = 'The GetCaps Method Was Used To Gather The Following Data For Portrait'
    cap_array = oprn~GetCaps
    oprn~PrintLine(text)
    oprn~PrintLine('dpix =' cap_array[1])
    oprn~PrintLine('dpiy =' cap_array[2])
    oprn~PrintLine('MarginLeft =' cap_array[3] / cap_array[1] 'Inches')
    oprn~PrintLine('MarginRight =' cap_array[4] / cap_array[1] 'Inches')
    oprn~PrintLine('PrintAreaHorz =' cap_array[5] / cap_array[1] 'Inches')
    oprn~PrintLine('PrintAreaVert =' cap_array[6] / cap_array[2] 'Inches')
    oprn~PrintLine('PhysWidth =' cap_array[7] / cap_array[1] 'Inches')
    oprn~PrintLine('PhysHeight =' cap_array[8] / cap_array[2] 'Inches')

    margin_left = cap_array[3] / cap_array[1]
    print_area_horz = cap_array[5] / cap_array[1]
    physical_width = cap_array[7] / cap_array[1]
    margin_right = physical_width - print_area_horz - margin_left

    paper_center = print_area_horz / 2

    th = oprn~TextHeight('A')
    oprn~CurrentY = oprn~CY + th

    text = 'This is a string of text in Arial 14 pt'
    oprn~PrintLine(text)
    tw = oprn~TextWidth(text)
    th = oprn~TextHeight(text)
    oprn~PrintLine('Its width is' tw'". Its height is' th'".')

    oprn~FontSize = 10
    text = 'This is a string of text in Arial 10 pt'
    oprn~PrintLine(text)
    tw = oprn~TextWidth(text)
    th = oprn~TextHeight(text)
    oprn~PrintLine('Its width is' tw'". Its height is' th'".')

    text = 'This text is in Bold'
    oprn~FontBold = .true
    oprn~PrintLine(text)
    oprn~FontBold = .false

    text = 'This text is in Italic'
    oprn~FontItalic = .true
    oprn~PrintLine(text)
    oprn~FontItalic = .false

    text = 'This text is in StrikeThru'
    oprn~FontStrikeThru = .true
    oprn~PrintLine(text)
    oprn~FontStrikeThru = .false

    text = 'This text is in UnderLine'
    oprn~FontUnderLine = .true
    oprn~PrintLine(text)
    oprn~FontUnderline = .false

    text = 'This text is in Bold, Italic, StrikeThru, & Underline'
    oprn~FontBold = .true
    oprn~FontItalic = .true
    oprn~FontStrikeThru = .true
    oprn~FontUnderLine = .true
    oprn~PrintLine(text)
    oprn~FontBold = .false
    oprn~FontItalic = .false
    oprn~FontStrikeThru = .false
    oprn~FontUnderLine = .false

    text = 'This Line Is Centered'
    tw = oprn~TextWidth(text)


    oprn~CurrentX = paper_center - (tw / 2)
    oprn~PrintLine(text)

    curX = oprn~CX
    curY = oprn~CY
    oprn~PrintLineS('CurrentX Before This Line =' curX'". CurrentY =' curY'". ')
    curX = oprn~CX
    curY = oprn~CY
    oprn~ForeColor = red
    oprn~PrintLine('CurrentX After The First Text Was =' curX'". CurrentY =' curY'".')
    oprn~ForeColor = black


    headers = 'First Name,Last Name'
    names.1 = 'Lee,Peedin'
    names.2 = 'Leeanderthal,Peedin'
    names.0 = 2

    oprn~PrintLine('The Following Table Was Printed With TABS')
    parse var headers h1','h2
    oprn~PrintLineT(h1,1)
    oprn~PointSet(oprn~CX,oprn~CY,black)
    oprn~PrintLineT(h2,2)
    oprn~PointSet(oprn~CX,oprn~CY,black)
    oprn~PrintLine('')
    oprn~PointSet(oprn~CX,oprn~CY,black)
    do aa = 1 to names.0
        parse var names.aa n1','n2
        oprn~PrintLineT(n1,1)
        oprn~PointSet(oprn~CX,oprn~CY,black)
        oprn~PrintLineT(n2,2)
        oprn~PointSet(oprn~CX,oprn~CY,black)
        oprn~PrintLine('')
        oprn~PointSet(oprn~CX,oprn~CY,black)
    end

    oprn~PrintLine('The Following Table Was Printed With POSITION')
    parse var headers h1','h2
    oprn~PrintLineP(h1,15)
    oprn~PointSet(oprn~CX,oprn~CY,black)
    oprn~PrintLineP(h2,30)
    oprn~PointSet(oprn~CX,oprn~CY,black)
    oprn~PrintLine('')
    oprn~PointSet(oprn~CX,oprn~CY,black)
    do aa = 1 to names.0
        parse var names.aa n1','n2
        oprn~PrintLineP(n1,15)
        oprn~PointSet(oprn~CX,oprn~CY,black)
        oprn~PrintLineP(n2,30)
        oprn~PointSet(oprn~CX,oprn~CY,black)
        oprn~PrintLine('')
        oprn~PointSet(oprn~CX,oprn~CY,black)
    end

    oprn~PrintLine("If you look real close you'll see a tiny PointSet indicating where the 'Cursor' was left after each PrintLine.")

    text = 'This text is rotated 180 degrees'
    tw = oprn~TextWidth(text)
    th = oprn~TextHeight(text)
    oprn~CurrentX = tw
    oprn~CurrentY = oprn~CY + th
    oprn~RotatedText(text,180)

    oprn~FontSize = 8
    text = 'Page Number' oprn~PageNo
    th = oprn~TextHeight(text)
    tw = oprn~TextWidth(text)
    PrintAreaVert = cap_array[6] / cap_array[2]
    PhysHeight = cap_array[8] / cap_array[2]
    Void_Bottom = PhysHeight - PrintAreaVert
    oprn~CurrentY = PhysHeight - Void_Bottom - th
    oprn~CurrentX = paper_center - (tw / 2)
    oprn~PrintLine(text)


    oprn~NewPage
    oprn~Orientation = 2
    oprn~CurrentY = .5

    oprn~FontSize = 8
    text = 'The GetCaps Method Was Used Again To Gather The Following Data For LandScape'
    cap_array = oprn~GetCaps
    oprn~PrintLine(text)
    oprn~PrintLine('dpix =' cap_array[1])
    oprn~PrintLine('dpiy =' cap_array[2])
    oprn~PrintLine('MarginLeft =' cap_array[3] / cap_array[1] 'Inches')
    oprn~PrintLine('MarginRight =' cap_array[4] / cap_array[1] 'Inches')
    oprn~PrintLine('PrintAreaHorz =' cap_array[5] / cap_array[1] 'Inches')
    oprn~PrintLine('PrintAreaVert =' cap_array[6] / cap_array[2] 'Inches')
    oprn~PrintLine('PhysWidth =' cap_array[7] / cap_array[1] 'Inches')
    oprn~PrintLine('PhysHeight =' cap_array[8] / cap_array[2] 'Inches')

    text = 'The Orientation Has Changed To LandScape For This Page'
    margin_left = cap_array[3] / cap_array[1]
    print_area_horz = cap_array[5] / cap_array[1]
    physical_width = cap_array[7] / cap_array[1]
    margin_right = physical_width - print_area_horz - margin_left

    paper_center = print_area_horz / 2

    text = 'This is centered in Landscape'
    tw = oprn~TextWidth(text)
    oprn~CurrentX = paper_center - (tw / 2)
    oprn~PrintLine(text)

    curY = oprn~CY
    text = 'You Could Use Circles To "Bullet" Text'
    th = oprn~TextHeight(text)
    oprn~DrawCircle(.06,curY + (th / 2),.03)
    oprn~CurrentY = curY
    oprn~PrintLineP(text,5)
    oprn~PrintLine('')

    curY = oprn~CY
    text = 'You Could Even Use Colored Circles To "Bullet" Special Text'
    th = oprn~TextHeight(text)
    oprn~DrawCircleC(.06,curY + (th / 2),.03,red)
    oprn~CurrentY = curY
    oprn~PrintLineP(text,5)
    oprn~PrintLine('')

    oprn~PrintLine(' ')
    save_curX = oprn~CX
    save_curY = oprn~CY
    text = 'Use DrawLine To Create Square Corner Boxes'
    oprn~PrintLine(text)
    curY = oprn~CY + .1
    curX = oprn~CX + .1

    oprn~DrawLine(curX,curY,curX+2,curY)            --Top
    oprn~DrawLine(curx,curY,curX,curY+2)            --Left
    oprn~DrawLine(curX,curY+2,curX+2,curY+2)        --Bottom
    oprn~DrawLIne(curX+2,curY,curX+2,curY+2)        --Right

    oprn~CurrentY = curY + 2.1
    oprn~CurrentX = 0
    text = 'Use DrawLineC To Create Colored-Square Corner Boxes'
    oprn~PrintLine(text)
    curY = oprn~CY + .1
    curX = oprn~CX + .1

    oprn~DrawLineC(curX,curY,curX+2,curY,blue)      --Top
    oprn~DrawLineC(curX,curY,curX,curY+2,blue)      --Left
    oprn~DrawLineC(curX,curY+2,curX+2,curY+2,blue)  --Bottom
    oprn~DrawLIneC(curX+2,curY,curX+2,curY+2,blue)  --Right

    pi = 3.141592
    oprn~CurrentX = save_curX + 5
    oprn~CurrentY = save_curY
    text = 'Use DrawLine & DrawArc To Create Round Corner Boxes'
    oprn~PrintLine(text)
    curY = oprn~CY + .1
    curX = oprn~CX + 5.1

    oprn~DrawLine(curX+.2,curY,curX+2-.2,curY)      --Top
    oprn~DrawLine(curX,curY+.2,curX,curY+2-.2)      --Left
    oprn~DrawLine(curX+.2,curY+2,curX+2-.2,curY+2)  --Bottom
    oprn~DrawLine(curX+2,curY+.2,curX+2,curY+2-.2)  --Right

    oprn~DrawArc(curX+.2,curY+.2,.2,pi*.5,pi)       --Top Left
    oprn~DrawArc(curX+2-.2,curY+.2,.2,0,pi*.5)      --Top Right
    oprn~DrawArc(curX+.2,curY+2-.2,.2,pi,pi*3/2)    --Bottom Left
    oprn~DrawArc(curX+2-.2,curY+2-.2,.2,pi*3/2,0)   --Bottom Right

    oprn~CurrentY = curY + 2.1
    oprn~CurrentX = save_curX + 5
    text = 'Use DrawLineC & DrawArcC To Create Colored-Round Corner Boxes'
    oprn~PrintLine(text)
    curY = oprn~CY + .1
    curX = oprn~CX + 5.1

    oprn~DrawLineC(curX+.2,curY,curX+2-.2,curY,blue)        --Top
    oprn~DrawLineC(curX,curY+.2,curX,curY+2-.2,blue)        --Left
    oprn~DrawLineC(curX+.2,curY+2,curX+2-.2,curY+2,blue)    --Bottom
    oprn~DrawLineC(curX+2,curY+.2,curX+2,curY+2-.2,blue)    --Right

    oprn~DrawArcC(curX+.2,curY+.2,.2,pi*.5,pi,blue)         --Top Left
    oprn~DrawArcC(curX+2-.2,curY+.2,.2,0,pi*.5,blue)        --Top Right
    oprn~DrawArcC(curX+.2,curY+2-.2,.2,pi,pi*3/2,blue)      --Bottom Left
    oprn~DrawArcC(curX+2-.2,curY+2-.2,.2,pi*3/2,0,blue)     --Bottom Right

    oprn~CurrentX = 0
    oprn~CurrentY = oprn~CY + .3
    save_currentY = oprn~CY
    oprn~PrintLine('Paint An Image')

--NOTE: Adjust the following for an image file on your system!
    curX = oprn~CX
    curY = oprn~CY
    image = 'c:\2005_symposium\oorexx.jpg'
    oprn~PaintPicture(image,curX,curY)

    oprn~CurrentX = 5
    oprn~CurrentY = save_currentY
    oprn~PrintLine('Paint A Resized Image (.6)')

--NOTE: Adjust the following for an image file on your system!
    curX = oprn~CX + 5
    curY = oprn~CY
    image = 'c:\2005_symposium\oorexx.jpg'
    image_array = oprn~Dimensions(image)
    oprn~PaintPictureR(image,curX,curY,image_array[1]*.6,image_array[2]*.6)

    oprn~FontSize = 8
    text = 'Page Number' oprn~PageNo
    th = oprn~TextHeight(text)
    tw = oprn~TextWidth(text)
    PrintAreaVert = cap_array[6] / cap_array[2]
    PhysHeight = cap_array[8] / cap_array[2]
    Void_Bottom = PhysHeight - PrintAreaVert
    oprn~CurrentY = PhysHeight - Void_Bottom - th
    oprn~CurrentX = paper_center - (tw / 2)
    oprn~PrintLine(text)

    if printer_change then
        call SysWinSetDefaultPrinter save_default_printer
exit

Bad_Error:
    oprn~KillDoc
    conobj = condition('o')
    lline = '--  Syntax Error On' date() time()
    do i over conobj
        if conobj[i] = .nil then do
            lline = lline'0d0a'x||i':'
        end
        else do
            select
                when i = 'ADDITIONAL' then do
                    lline = lline'0d0a'x||i':'
                    if conobj[i]~string = .array~new()~string then do a = 1 to conobj[i]~items()
                        lline = lline'0d0a'x||conobj[i][a]
                    end
                    else lline = lline'0d0a'x||conobj[i]
                end
                when i = 'TRACEBACK' then do
                    lline = lline'0d0a'x||i':'
                    tba = conobj[i]~makearray()
                    do t = 1 to tba~items()
                        lline = lline'0d0a'x||tba[t]
                    end
                end
                otherwise lline = lline'0d0a'x||i':' conobj[i]
            end
        end
    end
    lline = lline'0d0a'x||'--  On Line' sigl

    call errorMessage(lline)
    call SysWinSetDefaultPrinter save_default_printer
exit

/*
If you're using ooRexx 1st Release, you'll have to move the oodplain.cls file from
the /program files/oorexx/oodialog/samples folder to a folder in your path - been told this will
be fixed in the next release.
*/

::REQUIRES OODPLAIN.CLS



