/* test_verifydates.rex */

    d_list = 'B D E L M N O S U W'
    t_list = 'C E H L M N R S'

    next_rtn = 'SelectDateTime'
    do until next_rtn = 'All_Done'
        interpret 'call' next_rtn
    end

All_Done:
    exit

SelectDateTime:
    drop tp.
    m_title = 'Date OR Time Validation Test'
    d_title = 'Select A Value Test Type'
    tp.1 = '&Date'
    tp.2 = '&Time'
    dlg = .SingleSelection~New(d_title,m_title,tp.,1,,5)
    stype = dlg~execute
    if stype = '' then next_rtn = 'All_Done'
    else do
        if stype = 1 then next_rtn = 'SelectDateType'
        else next_rtn = 'SelectTimeType'
    end
return

SelectTimeType:
    drop tp.
    m_title = 'Verify Times'
    d_title = 'Select The Time TYPE To Verify'
    tp.1 = '&Civil'
    tp.2 = '&Elasped'
    tp.3 = '&Hours'
    tp.4 = '&Long'
    tp.5 = '&Minutes'
    tp.6 = '&Normal'
    tp.7 = '&Reset'
    tp.8 = '&Seconds'

    dlg = .SingleSelection~New(d_title,m_title,tp.,1,,4)
    stype = dlg~execute
    if stype = '' then next_rtn = 'SelectDateTime'
    else do
        type = t_list~word(stype)
        next_rtn = 'GetTimeValue'
    end
return

GetTimeValue:
    d_title = '"'type'"' 'Expected Format ->'
    select
        when stype = 1 then d_title = d_title 'hH:MMam/pm'
        when stype = 2 then d_title = d_title ''
        when stype = 3 then d_title = d_title 'Positive Whole Number'
        when stype = 4 then d_title = d_title 'HH:MM:SS.DDDDDD'
        when stype = 5 then d_title = d_title 'Positive Whole Number'
        when stype = 6 then d_title = d_title 'HH:MM:SS'
        when stype = 7 then d_title = d_title ''
        when stype = 8 then d_title = d_title 'Positive Whole Number'
        otherwise
            nop
    end

    lab.1 = 'A Time Value'
    labv.101 = ''
    dlg = .MultiInputBox~New(d_title,m_title,lab.,labv.)

    if dlg~execute = 1 then do
        ctime = dlg~ATimeValue
        next_rtn = 'TestTimeType'
    end
    else next_rtn = 'SelectTimeType'
return

TestTimeType:
    drop tt.
    d_title = 'Select A Test Type'
    tt.1 = 'Reason Test'
    tt.2 = 'True/False Test Only'
    dlg = .SingleSelection~New(d_title,m_title,tt.,1,,5)
    ttype = dlg~execute
    select
        when ttype = '' then next_rtn = 'GetTimeValue'
        when ttype = 1 then next_rtn = 'R_Time_Test'
        otherwise
            next_rtn = 'TF_Time_Test'
    end
return

R_Time_Test:
    rv = RxIsTime(ctime,type)
    if rv = 1 then call infoMessage('(Value' ctime 'Type' type')' 'OK')
    else call errorMessage('(Value' ctime 'Type' type')' rv)
    next_rtn = 'TestTimeType'
return


TF_Time_Test:
    if TimeType(ctime,type) then call infoMessage('(Value' ctime 'Type' type')' 'TRUE')
    else call errorMessage('(Value' ctime 'Type' type')' 'FALSE')
    next_rtn = 'TestTimeType'
return

SelectDateType:
    drop tp.
    m_title = 'Verify Dates'
    d_title = 'Select The Date TYPE To Verify'
    tp.1 = '&Base'
    tp.2 = '&Days'
    tp.3 = '&European'
    tp.4 = '&Language'
    tp.5 = '&Month'
    tp.6 = '&Normal'
    tp.7 = '&Ordered'
    tp.8 = '&Standard'
    tp.9 = '&USA'
    tp.10 = '&Weekday'

    dlg = .SingleSelection~New(d_title,m_title,tp.,1,,5)
    stype = dlg~execute
    if stype = '' then next_rtn = 'SelectDateTime'
    else do
        type = d_list~word(stype)
        next_rtn = 'GetDateValue'
    end
return

GetDateValue:
    d_title = '"'type'"' 'Expected Format ->'
    select
        when stype = 1 then d_title = d_title 'Positive Number'
        when stype = 2 then d_title = d_title 'Positive Number'
        when stype = 3 then d_title = d_title 'dd/mm/yy'
        when stype = 4 then d_title = d_title 'Language Specific'
        when stype = 5 then d_title = d_title 'Month In English'
        when stype = 6 then d_title = d_title 'dd mon yyyy'
        when stype = 7 then d_title = d_title 'yy/mm/dd'
        when stype = 8 then d_title = d_title 'yyyymmdd'
        when stype = 9 then d_title = d_title 'mm/dd/yy'
        when stype = 10 then d_title = d_title 'Day of Week In English'
        otherwise
            nop
    end

    lab.1 = 'A Date Value'
    labv.101 = ''
    dlg = .MultiInputBox~New(d_title,m_title,lab.,labv.)

    if dlg~execute = 1 then do
        cdate = dlg~ADateValue
        next_rtn = 'TestDateType'
    end
    else next_rtn = 'SelectDateType'
return

TestDateType:
    drop tt.
    d_title = 'Select A Test Type'
    tt.1 = 'Reason Test'
    tt.2 = 'True/False Test Only'
    dlg = .SingleSelection~New(d_title,m_title,tt.,1,,5)
    ttype = dlg~execute
    select
        when ttype = '' then next_rtn = 'GetDateValue'
        when ttype = 1 then next_rtn = 'R_Date_Test'
        otherwise
            next_rtn = 'TF_Date_Test'
    end
return

R_Date_Test:
    rv = RxIsDate(cdate,type)
    if rv = 1 then call infoMessage('(Value' cdate 'Type' type')' 'OK')
    else call errorMessage('(Value' cdate 'Type' type')' rv)
    next_rtn = 'TestDateType'
return

TF_Date_Test:
    if DateType(cdate,type) then call infoMessage('(Value' cdate 'Type' type')' 'TRUE')
    else call errorMessage('(Value' cdate 'Type' type')' 'FALSE')
    next_rtn = 'TestDateType'
return

::Requires 'ELPDateTime.rex'
::Requires 'oodplain.cls'
